﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;
using TengoPlan4U.Models;

namespace TengoPlan4U.Controllers
{
    public class HomeController : Controller
    {
        private TengoPlanEntities tengoPlanDb = new TengoPlanEntities();

        public ActionResult Index()
        {
            HomeViewModel result = new HomeViewModel();
            UsuarioRegistrado user = tengoPlanDb.UsuariosRegistrados.Where(u => u.Email.Equals(User.Identity.Name)).FirstOrDefault();
            if (User.Identity.IsAuthenticated)
            {
                if(Session["HasRecom"] == null)
                {
                    Session["localesRecom"] = Comunes.GetRecomendaciones(User.Identity.Name);
                    if (Session["localesRecom"] != null)
                    {
                        Session["HasRecom"] = true;
                    }
                    else
                    {
                        Session["HasRecom"] = false;
                    }
                }
                bool HasRecom = (bool)Session["HasRecom"];
                if (HasRecom)
                    result.HasRecom = true;
            }
            result.TiposPlanes = tengoPlanDb.TiposPlanes.ToList();
            result.Ciudades = tengoPlanDb.Ciudades.ToList().OrderBy(c => c.Nombre);
            return View(result);
            //}
        }

        [HttpPost]
        [AllowAnonymous]
        [ValidateAntiForgeryToken]
        public ActionResult Index(HomeViewModel model)
        {
            Plan busquedaPlan = model.Plan;
            Ciudad ciudad = tengoPlanDb.Ciudades.Where(c => c.CiudadId.Equals(busquedaPlan.CiudadId)).FirstOrDefault();
            string direccion = busquedaPlan.Zona.Trim().Replace(" ", "+") + "+" + ciudad.Nombre;
            TipoPlan tipoPlan = tengoPlanDb.TiposPlanes.Where(c => c.TipoPlanId.Equals(busquedaPlan.TipoPlanId)).FirstOrDefault();
            if (User.Identity.IsAuthenticated)
            {
                HttpCookie cookie = new HttpCookie("tengoPlan4U_ck_" + User.Identity.Name, direccion + "|" + tipoPlan.Nombre);
                cookie.Expires = DateTime.Today.AddMonths(6);
                Response.Cookies.Add(cookie);
            }
            return RedirectToAction("TuPlan", "Plans", new { direccion = direccion, tipoPlan = tipoPlan.Nombre });
        }


        public ActionResult TuPlan()
        {
            return View();
        }


        public ActionResult About()
        {
            ViewBag.Message = "Tenemos tu plan.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Datos de contacto.";

            return View();
        }
    }
}