﻿using Microsoft.AspNet.Identity;
using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Linq;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;
using TengoPlan4U.Models;

namespace TengoPlan4U.Controllers
{
    public class OpinionController : Controller
    {
        private TengoPlanEntities _tengoPlanDb = new TengoPlanEntities();


        // GET: Opinion
        public ActionResult TusOpiniones(string cookieName, string cookiePlan)
        {
            Request.Cookies[cookieName].Expires = DateTime.Now;
            string[] datosCokie = cookiePlan.Split('|');
            string direccion = datosCokie[0].Replace("+", " ");
            string tipoPlan = datosCokie[1];
            string coordinates = Comunes.GetCoordinates(direccion);
            List<Local> listaLocales = Comunes.GetPlaces(coordinates, tipoPlan);
            List<OpinionViewModel> opiniones = new List<OpinionViewModel>();
            foreach (Local local in listaLocales)
            {
                OpinionViewModel op = new OpinionViewModel();
                op.GooglePlaceId = local.GooglePlaceId;
                op.Direccion = local.Direccion;
                op.Nombre = local.Nombre;
                op.Zona = direccion;
                opiniones.Add(op);
            }
            return View(opiniones);
        }

        [HttpPost]
        [AllowAnonymous]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> TusOpiniones(List<OpinionViewModel> opiniones, int cont)
        {
            int guardado = 0;
            string UserName = User.Identity.Name;
            UsuarioRegistrado user = _tengoPlanDb.UsuariosRegistrados.Where(u => u.Email.Equals(UserName)).FirstOrDefault();
            foreach(OpinionViewModel op in opiniones)
            {
                if (op.Rating > 0)
                {
                    var valoracion = new Opinion
                    {
                        Comentarios = op.Comentarios.Trim() != "" ? op.Comentarios : "",
                        GooglePlaceId = op.GooglePlaceId,
                        Rating = op.Rating,
                        Zona = op.Zona,
                        UsuarioId = user.UsuarioRegistradoId
                    };
                    Opinion opExistente = _tengoPlanDb.Opiniones.Where(o => o.GooglePlaceId.Equals(valoracion.GooglePlaceId) && o.UsuarioId.Equals(valoracion.UsuarioId)).FirstOrDefault();
                    if (opExistente != null)
                    {
                        opExistente.Comentarios = valoracion.Comentarios;
                        opExistente.Rating = valoracion.Rating;
                        _tengoPlanDb.SaveChanges();
                    }
                    else
                    {
                        _tengoPlanDb.Opiniones.Add(valoracion);
                        guardado = await _tengoPlanDb.SaveChangesAsync();
                    }
                }
            }
            //if (guardado > 0)
            //{
                return RedirectToAction("Index", "Home");
            //}
        }

        public ActionResult GoHome()
        {
            return RedirectToAction("Index", "Home");
        }

        

        public ActionResult VerOpiniones(string placeId)
        {
            VerOpinionViewModel result = new VerOpinionViewModel();
            List<Opinion> opiniones = _tengoPlanDb.Opiniones.Where(o => o.GooglePlaceId.Equals(placeId)).ToList();
            result.Opiniones = opiniones;
            GooglePlaceDetails.Rootobject place = Comunes.GetPlaceDetails(placeId);
            result.NombreLocal = place.result.name;
            result.DireccionLocal = place.result.formatted_address;
            return View(result);
        }


        // GET: Opinion/Details/5
        public ActionResult Details(int id)
        {
            return View();
        }

        // GET: Opinion/Create
        public ActionResult Create()
        {
            return View();
        }

        // POST: Opinion/Create
        [HttpPost]
        public ActionResult Create(FormCollection collection)
        {
            try
            {
                // TODO: Add insert logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        // GET: Opinion/Edit/5
        public ActionResult Edit(int id)
        {
            return View();
        }

        // POST: Opinion/Edit/5
        [HttpPost]
        public ActionResult Edit(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add update logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        // GET: Opinion/Delete/5
        public ActionResult Delete(int id)
        {
            return View();
        }

        // POST: Opinion/Delete/5
        [HttpPost]
        public ActionResult Delete(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add delete logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }
    }
}
