﻿using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Linq;
using System.Web;

namespace TengoPlan4U.Models
{
    public class TengoPlanEntities : DbContext
    {
        public DbSet<Ciudad> Ciudades { get; set; }
        public DbSet<Comunidad> Comunidades { get; set; }
        public DbSet<Especialidad> Especialidades { get; set; }
        public DbSet<Local> Locales { get; set; }
        public DbSet<Opinion> Opiniones { get; set; }
        public DbSet<Plan> Planes { get; set; }
        public DbSet<TipoPlan> TiposPlanes { get; set; }
        public DbSet<Provincia> Provincias { get; set; }
        public DbSet<Recomendacion> Recomendaciones { get; set; }
        public DbSet<UsuarioRegistrado> UsuariosRegistrados { get; set; }
        public DbSet<VoteLog> VoteLogs { get; set; }

        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            modelBuilder.Entity<Ciudad>().ToTable("Ciudades");
            modelBuilder.Entity<Comunidad>().ToTable("Comunidades");
            modelBuilder.Entity<Especialidad>().ToTable("Especialidades");
            modelBuilder.Entity<Local>().ToTable("Locales");
            modelBuilder.Entity<Opinion>().ToTable("Opiniones");
            modelBuilder.Entity<Plan>().ToTable("Planes");
            modelBuilder.Entity<TipoPlan>().ToTable("TiposPlanes");
            modelBuilder.Entity<Recomendacion>().ToTable("Recomendaciones");
            modelBuilder.Entity<UsuarioRegistrado>().ToTable("UsuariosRegistrados");
            modelBuilder.Entity<VoteLog>().ToTable("VoteLogs");

            base.OnModelCreating(modelBuilder);
        }
    }
}